<?php

include __DIR__.'/SiteProApiClient.php';

use Profis\SitePro\SiteProApiClient;

// get "your_api_username" and "our_api_password" from your license and enter them here
// use this for premium/free licenses
$api = new SiteProApiClient('http://site.pro/api/', 'your_api_username', 'your_api_password');
// use this for enterprise licenses and change 'your-bulder-domain.com' to your builder domain
//$api = new SiteProApiClient('http://your-bulder-domain.com/api/', 'your_api_username', 'your_api_password');

try {
	// Note: parameter value types must match documentation
	// (ex.: parameter 'suborderId' type is Number, so "'suborderId' => 2410" is correct and "'suborderId' => '2410'" is incorrect )
	$res = $api->remoteCall('ipList', array(
		'suborderId' => 4310, // suborder ID from your license
		'action' => 'list' // list all added IP's
	));
	
	/*$res = $api->remoteCall('ipList', array(
		'suborderId' => 4310, // suborder ID from your license
		'action' => 'add', // add new IP
		'ip' => '0.0.0.0' // IP you want to add
	));*/
	
	/*$res = $api->remoteCall('ipList', array(
		'suborderId' => 4310, // suborder ID from your license
		'action' => 'delete', // remove IP
		'ip' => '0.0.0.0' // IP you want to remove
	));*/
	
	/*$res = $api->remoteCall('ipList', array(
		'suborderId' => 4310, // suborder ID from your license
		'action' => 'update', // update IP
		'ip' => '0.0.0.0', // IP you want to update
		'newIp' => '0.0.0.0' // new IP you want to set
	));*/
	
	if (!$res || !is_object($res)) {
		throw new ErrorException('Response format error');
	} else if (isset($res->ok) && $res->ok) {
		echo 'Request success: '.print_r($res, true);
	} else {
		throw new ErrorException((isset($res->error->message) && $res->error->message) ? $res->error->message : 'Unknown error');
	}
} catch(ErrorException $ex) {
	echo 'Request error: '.$ex->getMessage();
}
